# ESP8266 ROM Bootloader Utility
# www.espressif.com
# iot.espressif.cn
# Copyright (C) 2014 Espressif Shanghai
#
# This program is a firmware download tool with a simple graphic user interface.
# Thanks to Fredrik Ahlberg's outstanding work of esptool.py
# Port form XTCOM,which is compiled via visual studio, to python so that it can also be running in linux
# 
# If any bug is figured out ,please send the bug description and console log to wangjialin@espressif.com or wangcostaud@hotmail.com


import wx
import combine_bin as cb
import os

[wxID_PANEL1, wxID_PANEL1BUTTON, wxID_PANEL1BUTTON1, wxID_PANEL1RADIOBOX1, 
 wxID_PANEL1RADIOBOX2, wxID_PANEL1STATICBOX1, wxID_PANEL1RADIOBOX3,
 wxID_PANEL2CHOICE_CRYSTAL,wxID_PANEL2STATICTEXT_CRYSTAL,
 
] = [wx.NewId() for _init_ctrls in range(9)]

class Panel_Combine(wx.Panel):
    def _init_ctrls(self, prnt,position):
        # generated method, don't edit
        wx.Panel.__init__(self, id=wxID_PANEL1, name='', parent=prnt,
              pos=position, size=wx.Size(255, 245),
              style=wx.TAB_TRAVERSAL)
        self.SetClientSize(wx.Size(252, 245))
        
        
        #****************************************************88
        self.choice_Crystal = wx.Choice(choices=["40M", "26M", "24M"],
                                        id=wxID_PANEL2CHOICE_CRYSTAL,
              name=u'choice_Crystal', parent=self, pos=wx.Point(16, 55),
              size=wx.Size(60, 30), style=0)
        self.choice_Crystal.SetSelection(1)
        self.choice_Crystal.Bind(wx.EVT_CHOICE, self.OnChoice_choice_Crystal,
              id=wxID_PANEL2CHOICE_CRYSTAL)
        
        self.staticCrystal = wx.StaticText(id=wxID_PANEL2STATICTEXT_CRYSTAL,
              label=u'CrystalFreq :', name=u'staticCrystal', parent=self,
              pos=wx.Point(16, 32), size=wx.Size(66, 17), style=0)   


        
        #****************************************************************************

        self.radioBoxSpeed = wx.RadioBox(choices=['40MHz', '26.7MHz', '20MHz',
              '80MHz'], id=wxID_PANEL1RADIOBOX1, label=u'SPI SPEED',
              majorDimension=1, name='radioBoxSpeed', parent=self, pos=wx.Point(14,
              83), size=wx.Size(70, 130), style=wx.RA_SPECIFY_COLS)
        self.radioBoxSpeed.Bind(wx.EVT_RADIOBOX, self.OnRadioBoxSpiSpeed,
              id=wxID_PANEL1RADIOBOX1)

        self.radioBoxMode = wx.RadioBox(choices=['QIO', 'QOUT', 'DIO',
              'DOUT'], id=wxID_PANEL1RADIOBOX2, label=u'SPI MODE',
              majorDimension=1, name='radioBox2', parent=self, pos=wx.Point(90,
              83), size=wx.Size(72, 130), style=wx.RA_SPECIFY_COLS)
        self.radioBoxMode.Bind(wx.EVT_RADIOBOX, self.OnRadioBoxSpiMode,
              id=wxID_PANEL1RADIOBOX2)
        
        #===========================================================
        
        self.radioBoxStorage = wx.RadioBox(choices=['4Mbit', '2Mbit', '8Mbit',
              '16Mbit','32Mbit'], id=wxID_PANEL1RADIOBOX3, label=u'FLASH SIZE',
              majorDimension=1, name='radioBox3', parent=self, pos=wx.Point(169,
              83), size=wx.Size(72, 150), style=wx.RA_SPECIFY_COLS)
        self.radioBoxStorage.Bind(wx.EVT_RADIOBOX, self.OnRadioBoxFlashSize,
              id=wxID_PANEL1RADIOBOX3)
        
        #===========================================================
        
        
        
        

        self.buttonCombine = wx.Button(id=wxID_PANEL1BUTTON1, label=u'CombineBin',
              name='buttonCombine', parent=self, pos=wx.Point(92, 32),
              size=wx.Size(70, 45), style=0)
        self.buttonCombine.Bind(wx.EVT_BUTTON, self.OnButtonConbine,
              id=wxID_PANEL1BUTTON1)

        self.staticBoxSpiConf = wx.StaticBox(id=wxID_PANEL1STATICBOX1,
              label=u'SPI FLASH CONFIG', name='staticBox1', parent=self,
              pos=wx.Point(6, 8), size=wx.Size(245, 230), style=0)

        self.buttonDefault = wx.Button(id=wxID_PANEL1BUTTON, label=u'Default',
              name=u'button', parent=self, pos=wx.Point(167, 32),
              size=wx.Size(70, 45), style=0)
        self.buttonDefault.Bind(wx.EVT_BUTTON, self.OnButtonDefault,
              id=wxID_PANEL1BUTTON)
        
        self.speed=self.radioBoxSpeed.GetSelection()
        self.mode=self.radioBoxMode.GetSelection()
        self.flashSize = self.radioBoxStorage.GetSelection()
        self.crystal = self.choice_Crystal.GetSelection()
        
        self.pp=self.frame.panel_path#    path_panel
        
        

    def __init__(self, parent, pos):
        self.frame = parent
        self._init_ctrls(parent,pos)
        

    def OnButtonConbine(self, event):
        res,dl_list = self.pp.check_all()
        if res == True:
            #try:
            cb.combineBin(dl_list,"combine/target.bin",self.mode,self.speed,self.flashSize,self.crystal)
            os.startfile('combine')
            #except:
                #print "open file error"
            
        else:
            pass
        event.Skip()

    def OnButtonDefault(self, event):
        self.radioBoxMode.SetSelection(0)
        self.mode=0
        self.radioBoxSpeed.SetSelection(0)
        self.speed=0
        self.radioBoxStorage.SetSelection(0)
        self.flashSize=0
        
        self.choice_Crystal.SetSelection(1)
        self.crystal = 1
        event.Skip()

    def OnRadioBoxSpiSpeed(self, event):
        self.speed = int( self.radioBoxSpeed.GetSelection())
        print "speed : ",self.radioBoxSpeed.GetSelection()
        event.Skip()

    def OnRadioBoxSpiMode(self, event):
        self.mode = int( self.radioBoxMode.GetSelection())
        print "mode : ",self.radioBoxMode.GetSelection()
        event.Skip()

    def OnRadioBoxFlashSize(self,event):
        self.flashSize = int( self.radioBoxStorage.GetSelection())
        print 'flash size :',self.radioBoxStorage.GetSelection()
        #print 'type : ',type(self.radioBoxStorage.GetSelection())
        event.Skip()
        
    def OnChoice_choice_Crystal(self,event):
        self.crystal = self.choice_Crystal.GetSelection()
        print 'crystal :',self.choice_Crystal.GetSelection()
        event.Skip()